#!/bin/sh
# the next line restarts using tclsh \
exec tclsh "$0"  --  ${1+"$@"}

set ::HOMEDIR [pwd ]

## main -- testeur de convmesh sur mailles elementaires
# 
# 
proc main { args } {
	
	puts "============================"
	puts " Testing elementary meshes  "
	puts "        msh -> mel"
	puts "============================"
	
	set nbErr 0
	
	puts "# managed by the mel format :"
	# tests des mailles elementaires gerees par le format mel
	set mshList [glob -nocomplain -join -directory $::HOMEDIR/data/mailelemOK *.msh]
	set melList [glob -nocomplain -join -directory $::HOMEDIR/data/mailelemOK *.mel]
	set mshRootList [glob -nocomplain -tails -directory $::HOMEDIR/data/mailelemOK *.msh]
	set melRootList [glob -nocomplain -tails -directory $::HOMEDIR/data/mailelemOK *.mel]
	
	set n [llength $mshList]
	
	for {set i 0} {$i < $n} {incr i} {
		file copy -force [lindex $mshList $i] $::HOMEDIR/[lindex $mshRootList $i]
		
		exec echo "c" | bin/convmesh [lindex $mshRootList $i] mel
				
		set res [read [open [lindex $melRootList $i]]]
		set ori [read [open [lindex $melList $i]]]
	
		if {[string equal $res $ori] == 1} {
			puts "    - [lindex $mshRootList $i] : OK"
		} {
			puts "    - [lindex $mshRootList $i] : ERROR"
			incr nbErr
		}
		
		file delete -force [lindex $mshRootList $i]
		file delete -force [lindex $melRootList $i]
	}
	
	puts "# not managed by the mel format :"
	# test des mailles elementaires non gerees par le format mel
	set mshList [glob -nocomplain -join -directory $::HOMEDIR/data/mailelemOthers *.msh]
	set mshRootList [glob -nocomplain -tails -directory $::HOMEDIR/data/mailelemOthers *.msh]

	set n [llength $mshList]
	
	set type(quadrangleQ2Serendipity.msh) quadrangleQ2Ser
	set type(cubeQ2Serendipity.msh) quadrangleQ2Ser
	set type(prismeO2Serendipity.msh) quadrangleQ2Ser
	set type(pyramideO2Serendipity.msh) quadrangleQ2Ser
	set type(triangleP3Inc.msh) triangleP3Inc
	set type(triangleP4Inc.msh) triangleP4Inc
	set type(triangleP5Inc.msh) triangleP5Inc
	
	for {set i 0} {$i < $n} {incr i} {
		file copy -force [lindex $mshList $i] $::HOMEDIR/[lindex $mshRootList $i]
		
		set cid [open "|echo \"c\" | bin/convmesh [lindex $mshRootList $i] mel"]
		set res [read $cid]

		set ori "=========================================================================
ERREUR err_melelem dans main->mesh::saveto_mel
le format mel ne supporte pas les elements $type([lindex $mshRootList $i]).
Consulter la doc de votre mailleur (gmsh ?) pour le forcer a definir les elements pleins.
=========================================================================
"
		
		if {[string equal $res $ori] == 1} {
			puts "    - [lindex $mshRootList $i] : OK"
		} {
			puts "    - [lindex $mshRootList $i] : ERROR"
			incr nbErr
		}
		
		file delete -force [lindex $mshRootList $i]
		file delete -force [lindex $melRootList $i]
	}
	
	puts "============================"
	puts "         $nbErr error(s)"
	puts "============================"
    exit
}

eval main $argv
